;+------------------------------------------------------+
;|	 _________     ________    _________		|
;|	/\   _____\   /  ____  \  /\   _____\		|
;|	\ \  \____/  /\  \   \  \ \ \  \____/		|
;|	 \ \  \_____ \ \  \   \  \ \ \  \_____		|
;|	  \ \_____  \ \ \  \   \  \ \ \_____  \		|
;|	   \/____/\  \ \ \  \   \  \ \/____/\  \	|
;|	     ____\_\  \ \ \  \___\  \  ____\_\  \	|
;|	    /\_________\ \ \________/ /\_________\	|
;|	    \/_________/  \/_______/  \/_________/ v2.0	|
;|							|
;+----------->by Joe Wingbermuehle 19990618<------------+
;| See sos.txt for information about SOS.		|
;| Please do not modify this code!			|
;| Visit my home page at:  http://joewing.calc.org	|
;| Send comments/bugs to:  joewing@calc.org		|
;+------------------------------------------------------+

	.nolist
	#include	"joeti83.inc"
	.org		$9327

#define	BASIC

;---------= Variables =---------
; Values stored in safe ram areas
storage		=cmdshad
keypress	=storage	; Value of last key press (1 byte)
progname	=storage+2	; Name of the highlighted program (10 bytes)
progloc		=storage+12	; Location of the program (leave room for type)
progsize	=storage+14	; Size of the program
nextprog	=storage+16	; Pointer to the next program in the vat
fatmap		=storage+18	; Program number/fat location (2*8=16 bytes)
modules		=storage+34	; Module location table (2x? bytes, 0 terminated)

; Values stored in instructions
#define	progdes		progdes_lbl+1	; pointer to the description
#define	number		number_lbl+1	; number of programs on the screen

; Values stored in instructions that must have a certain value at startup
#define	highlighted	highlighted_lbl+1	; number of the highlighted program
#define	curfat		curfat_lbl+1	; pointer to the start of the page in the vat

	.list

;---------= Beginning of SOS! =---------
startofsos:
	set	1,(iy+8)
	ld	hl,$8600
	ld	a,h
	ld	bc,$0093
loadInterrupt:
	ld	(hl),c
	inc	hl
	djnz	loadInterrupt
	ld	(hl),c
	ld	i,a

;----> Look Up & Run Modules
	ld	a,$C9
	ld	(modulemode),a
	ld	de,(fat)
	ld	hl,modules
getModuleLoop:
	push	hl
	ex	de,hl
	call	findprog
	ex	de,hl
	pop	hl
	jr	nz,endModuleLoop
	ld	bc,(progloc)
	ld	a,(bc)
	or	a
	jr	nz,getModuleLoop
	inc	bc
	ld	a,(bc)
	dec	a
	jr	nz,getModuleLoop
	ld	(hl),c
	inc	hl
	ld	(hl),b
	inc	hl
	jr	getModuleLoop
endModuleLoop:
	xor	a
	ld	(hl),a
	ld	(modulemode),a
	dec	a
	ld	(keypress),a
	call	runModules

curfat_lbl:
	ld	hl,$0000
	ld	a,h
	or	l
	jr	nz,ppstrt
strtpg:	ld	hl,(fat)
ppstrt:	ld	(nextprog),hl
start:	call	_indicatorOff
	call	_clrgbuf
	set	7,(iy+20)

	ld	hl,(nextprog)
	ld	(curfat),hl
	xor	a
	ld	(number),a
	ld	hl,fatmap

;-----> Check for 2nd+on and prevent it
	jr	interrupt_end
interrupt_start:
	ex	af,af'
	in	a,(3)
	rra
	jr	nc,on_not_pressed
	res	3,(iy+18)
on_not_pressed:
	jp	$0039
interrupt_end:

	ld	bc,8*256+7
dispp:	push	bc
	push	hl
	ld	hl,(nextprog)
	call	findprog
	ld	(nextprog),hl
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	pop	bc
	jr	nz,nomore
	push	hl
	ld	l,$01
	ld	h,c
	ld	(pencol),hl
progdes_lbl:
	ld	hl,$0000
	call	_vputs
	ld	hl,number
	inc	(hl)
	pop	hl
	ld	a,6
	add	a,c
	ld	c,a
	ld	a,$DA
	ld	(running),a
	djnz	dispp
nomore:
running:
	jp	nc,exit		; will be either jp nc or jp c (not taken if nc)
number_lbl:
	ld	a,$00
	or	a
	jr	z,strtpg
progsx:	jr	strthl

;---------= Wait for a key press (with APD) =----------
main:	im	2
	res	4,(iy+9)
	set	0,(iy+3)
	call	_getkey
	or	a
	jr	nz,remainOn
	ld	hl,$0102
	ld	($8009),hl
	jr	main
remainOn:
	im	1
	ld	(keypress),a

;---------= Main loop =---------
	ld	hl,highlighted
	cp	73	; [Y=]
	jr	z,run
	cp	5	; [ENTER]
	jr	z,run
	cp	64	; [2nd]+[MODE]
	jr	z,runModules
	cp	1	; [(right)]
	jr	nz,wrong
	ld	(hl),a
	jp	start
wrong:	ld	de,number
	ld	b,(hl)
	sub	3	; [(up)]
	jr	z,up
	dec	a	; [(down)]
	jr	z,down
	ld	hl,$9327
	push	hl

;---------= Run Modules =---------
runModules:
	ld	hl,modules
runNextModule:
	ld	a,(hl)
	or	a
	ret	z
	ld	c,a
	inc	hl
	ld	b,(hl)
	inc	hl
	push	hl
	call	executeModule
	pop	hl
	or	a
	jr	nz,runNextModule
	pop	hl
	sbc	hl,hl
	ld	(curfat),hl
	inc	a
	ld	(highlighted),a
	ld	a,$D2
	ld	(running),a
rBegin:	jp	$9327

;---------= Move the highlight =---------
down:	ld	a,(de)
	sub	(hl)
	jr	nz,mdown
	ld	(hl),a
mdown:	inc	(hl)
mvcomp:	call	hilight
strthl:	call	dispdes
premain:
	jr	main
up:	dec	(hl)
	jr	nz,mvcomp
	ld	a,(de)
	ld	(hl),a
	jr	mvcomp

;---------= Run a program =---------
run:	call	getdata

;-----> Run BASIC program
#ifdef BASIC
basicflag:
	nop			; either nop ($00) or ccf ($3E)
	jr	nc,runAsm
	call	_clrwin
	ld	hl,progname
	rst	20h
	set	1,(iy+8)
	ld	hl,(usermemoff)
	push	hl
	call	$4E8C
	pop	hl
	ld	(usermemoff),hl
	jr	rBegin
#endif
;-----<

runAsm:	ld	hl,(progloc)	; run asm program
	push	hl		; check for libs
	inc	hl
	inc	hl
	inc	hl
	call	_ldhlind
	pop	de
	ld	a,h
	or	l
	jr	z,nolibs
	add	hl,de

;-----> Setup library vectors
	; Vector definitions have the following format:
	; "LIB",0,0,0,0,0,libnum,vectnum,[$FF if no more]
libll:	dec	hl
	rst	20h
	ld	a,5
	ld	(op1),a
	push	hl
	call	_chksysvar
	inc	de
	inc	de
	pop	hl
	jr	nc,libfnd

libNotFound:
	call	clearSection	; Error if library file not found
;	xor	a		; a=0
	ld	(pencol),a	; penrow=57
	call	_bufcopy
	ld	hl,op1+1
	call	_vputs
	jr	premain

libfnd:	ld	c,(hl)	; lib number (mult of 2)
	push	hl
	ex	de,hl
;	ld	b,$00	; b=0
	push	hl
	add	hl,bc
	call	_ldhlind
	pop	de
	add	hl,de
	ex	de,hl
	pop	hl
	inc	hl
	ld	c,(hl)	; vector number (mult of 3)
	push	hl
;	ld	b,$00	; b=0
	ld	hl,cmdshad+40
	add	hl,bc
	ld	(hl),$C3	; jp xxxx
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	hl
	inc	hl
	ld	a,(hl)
	inc	a
	jr	nz,libll

;-----> Load and Run the asm program
#define	loadarea	cmdshad+(26-(swap-hook))	; swap must be at cmdshad+26!

nolibs:	call	_clrfull
	call	_clrgbuf
	ld	de,(progloc)
	ld	bc,(progsize)
	push	bc
	push	de
	ld	bc,hookend-hook
	ld	de,loadarea
	ld	hl,hook
	ldir
	pop	de
	pop	bc
	ld	hl,$9327
	jp	loadarea

hook:	push	bc
ex1:	call	sos_swap
	inc	hl
	inc	de
	jr	nz,ex1
	push	de
	push	hl
	call	$9327
	pop	hl
	pop	de
	pop	bc
ex2:	dec	hl
	dec	de
	call	sos_swap
	jr	nz,ex2
	jp	(hl)

swap:	ld	a,(hl)
	push	af
	ld	a,(de)
	ld	(hl),a
	pop	af
	ld	(de),a
	dec	bc
	ld	a,b
	or	c
	ret
hookend:

;---------= Get info on highlighted prog =---------
getdata:
	ld	hl,fatmap-2
highlighted_lbl:
	ld	bc,$0001
	add	hl,bc
	add	hl,bc
	call	_ldhlind

;---------= Detect programs =---------
findprog:
findlp:	push	hl
	ld	a,(hl)
	cp	$0D
	jr	z,list
	dec	a	; 1
	jr	z,list
	sub	$04	; 5
	jr	z,chkprg
	dec	a	; 6
	pop	de
	ret	nz
	push	de
chkprg:	dec	hl
	ld	b,(hl)
	dec	hl
	push	hl
	ld	h,(hl)
	ld	l,b
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(progsize),de
	inc	hl
	ld	(progloc),hl
	ld	a,(modulemode)
	or	a
	jr	nz,nogood

;-----> Basic program detection
#ifdef BASIC
;	xor	a		; already 0
	ld	de,basicflag
	ld	(de),a
	ld	a,(hl)
	cp	$3E		; ':'
	jr	nz,notbasic
	inc	a
	ld	(de),a		; $3F (ccf) if BASIC
	ld	hl,progname+1
	jr	basicEnter
notbasic:
#endif
;-----<

;-----> Assembler Program Detection
	inc	hl
	ld	a,(hl)
	cp	$18	; jr xx
	jr	nz,nogood
	dec	hl
	push	hl
	ld	de,$0005
	add	hl,de
	call	_ldhlind
	ld	de,-$9327
	add	hl,de
	pop	de
	add	hl,de
basicEnter:
	ld	(progdes),hl
	pop	hl
	dec	hl
	ld	b,(hl)
	ld	a,6
	add	a,b
	ld	(namelength+1),a
	ld	de,progname
	ld	a,5
	ld	(de),a
	inc	de
skprog:	dec	hl
	ld	a,(hl)
	ld	(de),a
	inc	de
	djnz	skprog
	xor	a
	ld	(de),a
	dec	hl
	pop	de
	ret

nogood:	pop	hl
list:	pop	hl
	dec	hl
	dec	hl
	dec	hl
	ld	b,(hl)
	inc	b
nogdlp:	dec	hl
	djnz	nogdlp
	xor	a
modulemode:
	nop		; can be ret(C9) or nop(00)
	jr	findlp

;---------= Disp hl in small font =---------
vdisphl:
	call	_setxxxxop2
	call	_op2toop1
	jp	_dispop1a

;---------= Show a description =---------
dispdes:
	call	getdata
	call	clearSection
	set	7,(iy+20)
	ld	hl,0*256+1
	ld	(pencol),hl
	ld	hl,sostxt
	call	_vputs		; title
	ld	hl,(64-7)*256+0
	ld	(pencol),hl
	ld	hl,progname+1
	call	_vputs		; progname
	ld	a,35
	ld	(pencol),a
namelength:
	ld	hl,$0000
	ld	de,(progsize)
	add	hl,de
	call	vdisphl
	ld	a,56
	ld	(pencol),a
	ld	hl,free
	call	_vputs
	call	_memfree
	call	vdisphl

exit:	ld	bc,(highlighted-1)
	res	7,(iy+20)

;---------= Highlight a program =---------
hilight:
	ld	l,b
	ld	h,6*12
	call	_htimesl
	ld	de,gbuf+12
	add	hl,de
	ld	b,12*7
hilightL:
	ld	a,(hl)
	cpl
	ld	(hl),a
	inc	hl
	djnz	hilightL
	jp	_bufcopy

;---------= Clear Bottom Section of Screen =---------
clearSection:
	ld	a,255
	ld	b,12
	ld	de,gbuf+(12*6)
	ld	hl,gbuf+(12*56)
clearLoop1:
	ld	(de),a
	ld	(hl),a
	inc	hl
	inc	de
	djnz	clearLoop1
	xor	a
	ld	b,12*6
clearLoop2:
	ld	(hl),a
	inc	hl
	djnz	clearLoop2
	ret

;---------= Execute a Module =---------
executeModule:
	ld	h,b
	ld	l,c
	inc	hl
	jp	(hl)

;---------= Dialog =---------
sostxt:	.db	"S0S 2.0 - Joe Wingbermuehle"
free:	.db	"Free:",0
endofsos:

.end

;SOS for the TI-83 created by Joe Wingbermuehle
